#property copyright "Copyright 2012,  .."
#property link      "alextar@bk.ru"
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_width1 2
#property indicator_color3 Green
#property indicator_width3 1
#property indicator_color4 Red
#property indicator_width4 1
#property indicator_color5 Red
#property indicator_width5 1
#property indicator_color6 Green
#property indicator_width6 1
#define  Version     "SF123ZZ"                     // 
#define  MyError     4999
#define  Zero        0.00000001
#define  Infinity    100000000.0
#define  TypesTotal  1
//    
double         Bottom[]    , Top[],                //  
               Min[]       , Max[],
               Down[]      , Up[],
               Time2[]     , Time3[],              //   
               LastBottom  , LastTop;              //  
int            iLastBottom , iLastTop,             //      
               iBottom     , iTop,
               iDown       , iUp,
               Number;                             //  
datetime       tLastBottom , tLastTop,             //   
               tBottom     , tTop,
               tDown       , tUp;
bool           LastIsTop   , LastIsBottom;         //  /
string         BullPrefix           =" Bull ",     //   
               BearPrefix           =" Bear ",
               ;
extern int         =119,          //  
                  =1,
                    =1,
                   =1,
                 =161,
                =161,
                   =159,
                    =159,
                        =2;
extern bool      =false,
                   =true,
                =false,
               =true,
                   =false,
                    =true,
                =true,
                   =false,
                    =false,
                    =true,
                       =true;
extern color      =PaleGreen,
               =LightPink;
//+------------------------------------------------------------------+
int init(){
   int DrawFractals=DRAW_NONE, DrawZigZag=DRAW_NONE, DrawRecoils=DRAW_NONE;
   if(  ) DrawFractals=DRAW_ARROW;
   if(  )  DrawZigZag  =DRAW_ZIGZAG;
   if(  )  DrawRecoils =DRAW_ARROW;
   SetIndexLabel(0,"Max");                         //  
   SetIndexBuffer(0,Max);
   SetIndexStyle(0,DrawZigZag);
   SetIndexEmptyValue(0,0);
   SetIndexLabel(1,"Min");
   SetIndexBuffer(1,Min);
   SetIndexStyle(1,DrawZigZag);
   SetIndexEmptyValue(1,0);
   SetIndexLabel(2,"Bottom");
   SetIndexBuffer(2,Bottom);
   SetIndexStyle(2,DrawFractals);
   SetIndexArrow(2,);
   SetIndexEmptyValue(2,0);
   SetIndexLabel(3,"Top");
   SetIndexBuffer(3,Top);
   SetIndexStyle(3,DrawFractals);
   SetIndexArrow(3,);
   SetIndexEmptyValue(3,0);
   SetIndexLabel(4,"Up");
   SetIndexBuffer(4,Up);
   SetIndexStyle(4,DrawRecoils);
   SetIndexArrow(4,);
   SetIndexEmptyValue(4,0);
   SetIndexLabel(5,"Down");
   SetIndexBuffer(5,Down);
   SetIndexStyle(5,DrawRecoils);
   SetIndexArrow(5,);
   SetIndexEmptyValue(5,0);
   SetIndexBuffer(6,Time2);
   SetIndexStyle(6,DRAW_NONE);
   SetIndexEmptyValue(6,0);
   SetIndexBuffer(7,Time3);
   SetIndexStyle(7,DRAW_NONE);
   SetIndexEmptyValue(7,0);
   IndicatorShortName(Version);
   =+"/"++"-"++"/"+;
   if(  <1 ) =1; //  
   if( <1 ) =1;
   if(   <1 ) =1;
   if(  <1 ) =1;
   LastBottom  =0;                                 // 
   LastTop     =0;
   iLastBottom =0;
   iLastTop    =0;
   tLastBottom =0;
   tLastTop    =0;
   LastIsTop   =false;
   LastIsBottom=false;
   iBottom     =0;
   iTop        =0;
   tBottom     =0;
   tTop        =0;
   iDown       =0;
   iUp         =0;
   tDown       =0;
   tUp         =0;
   Number      =0;
   ClearScreen();                                  //  
   WindowRedraw();                                 //  
   return(0);
}
//+------------------------------------------------------------------+
int deinit(){
   if(  ){
      ClearScreen();                               //  
      WindowRedraw();                              //  
   }
   return(0);
}
//+------------------------------------------------------------------+
int start(){
   int i, History=Bars-1;
   int BarsLost=History-IndicatorCounted();
   if( BarsLost<History ){                         //   
      if( BarsLost<1 ) return(0);
      i=+1+BarsLost;
   }
   else i=History-;
   int j, BarC, BarR, imax, imin, NewNumber, Error,
       , , ;
   double High1, Low1, High2, Low2, High3, Low3, Price;
   if( tUp>0 ) iUp=iBarShift(NULL,0,tUp);          //   
   if( tDown>0 ) iDown=iBarShift(NULL,0,tDown);
   if( tTop>0 ) iTop=iBarShift(NULL,0,tTop);
   if( tBottom>0 ) iBottom=iBarShift(NULL,0,tBottom);
   if( tLastTop>0 ) iLastTop=iBarShift(NULL,0,tLastTop);
   if( tLastBottom>0 ) iLastBottom=iBarShift(NULL,0,tLastBottom);
   imax=0;
   imin=0;
   High1=0;
   Low1=Infinity;
   j=+1;
   while( j>1 ){                                   //  
      j--;
      if( High[j]-High1>Zero ){
         imax=j;
         High1=High[imax];
      }
      if( Low1-Low[j]>Zero ){
         imin=j;
         Low1=Low[imin];
   }  }
   if( ! ) =EMPTY;
   Error=fLine(+" Support","Support",0,imin,Low1,0,Low1
              ,0,0,indicator_color3,,);
   Error=fLine(+" Resistance","Resistance",0,imax,High1,0,High1
              ,0,0,indicator_color4,,);
   while( i>1 ){
      fSoftFractals(i,iBottom,iTop,Bottom,Top,,);
      if( Top[i]>Zero ){                           //   
         iTop=i;
         iUp=i;
         Up[i]=Top[i];
         if( Bottom[i]>Zero ){                     // Top  Bottom
            iBottom=i;
            iDown=i;
            Down[i]=Bottom[i];
            if( LastIsTop || LastIsBottom ){       //   
               Min[i]     =Bottom[i];              //  
               Max[i]     =Top[i];
               LastBottom =Bottom[i];              //  Top  Bottom
               iLastBottom=i;
               LastTop    =Top[i];
               iLastTop   =i;
         }  }
         else{                                     // Top
            if( !LastIsTop ){                      // LastIsBottom, 
               Max[i]      =Top[i];                //     
               LastIsTop   =true;
               LastIsBottom=false; 
               LastTop     =Top[i];                //  Top
               iLastTop    =i;
            }
            else{                                  // LastIsTop
               if( Top[i]-LastTop>-Zero ){         // 
                  Max[iLastTop]=0;
                  Max[i]       =Top[i];
                  LastTop      =Top[i];            //  Top
                  iLastTop     =i;
      }  }  }  }
      else{
         if( Bottom[i]>Zero ){                     // Bottom
            iBottom=i;
            iDown=i;
            Down[i]=Bottom[i];
            if( !LastIsBottom ){                   // LastIsTop, 
               Min[i]      =Bottom[i];             //     
               LastIsTop   =false;
               LastIsBottom=true; 
               LastBottom  =Bottom[i];             //  Bottom
               iLastBottom =i;
            }
            else{                                  // LastIsBottom
               if( LastBottom-Bottom[i]>-Zero ){   // 
                  Min[iLastBottom]=0;
                  Min[i]          =Bottom[i];
                  LastBottom      =Bottom[i];      //  Bottom
                  iLastBottom     =i;
         }  }  }
         else{                                     //  
            fSoftFractals(i,iDown,iUp,Down,Up,,);
            if( Down[i]>Zero ){                    //   3
               iDown=i;
               Low3=Down[i];
               if( Up[i]>Zero ){                   // Up  Down
                  iUp=i;
                  High3=Up[i];
               }
               else{                               // Down
                  High3=0;
            }  }
            else{
               if( Up[i]>Zero ){                   // Up
                  iUp=i;
                  High3=Up[i];
                  Low3=0;
               }
               else{                               //   3
                  i--;
                  continue;
            }  }
            High1=0;
            Low1=0;
            imax=0;
            High2=0;
            imin=0;
            Low2=Infinity;
            if( ! ) =EMPTY;
            if( ! )   =EMPTY;
            j=i+1;
            while( j<History- ){  //   1  2
               if( Bottom[j]>Zero ){
                  if( Top[j]<Zero ){               // Low1
                     Low1=Bottom[j];
                     if( Low1-Low3>-Zero || Low3-High2>Zero
                      || Low3<Zero || High2<Zero ) break;
                     fBreakPoint(+BearPrefix+NewNumber,i,Low1 ,0,1,BarC,Price);
                     fBreakPoint(+BearPrefix+NewNumber,i,High2,0,1,BarR,Price);
                     if( ! && BarC>BarR ) break;
                     if( BarR>=i- &&  ! ) break;
                     if( Time2[j]>0 || Time3[j]>0 ){
                        NewNumber=fNumberByPoints(+BullPrefix,j,Low1);
                        if( NewNumber<1 || NewNumber>Number ) break;
                        if( Low[iBarShift(NULL,0,Time3[j])]-Low3>-Zero
                         && High[iBarShift(NULL,0,Time2[j])]-High2>-Zero
                         &&  ){
                           Error=fFiboLevels(+BullPrefix,NewNumber,j,Low1,imax,High2,i,Low3
                                            ,indicator_color3,indicator_color4,,);
                           Time3[j]=Time[i];
                        }
                        if( ! ) break;
                     }
                     else{
                        Number++;
                        NewNumber=Number;
                        if( BarC>BarR ) break;
                     }
                     if( BarR<1 ) BarR=1;
                     Error=fRectangle(+BullPrefix,BullPrefix,NewNumber
                                     ,j,Low1,BarR,High2,imax,Low3,,);
                     Error=fFiboLevels(+BullPrefix,NewNumber,j,Low1,imax,High2,i,Low3
                                      ,indicator_color3,indicator_color4,,);
                     Time2[j]=Time[imax];
                     Time3[j]=Time[i];
                     break;
               }  }
               else{
                  if( Top[j]>Zero ){               // High1
                     High1=Top[j];
                     if( High3-High1>-Zero || Low2-High3>Zero
                      || High3<Zero || Low2<Zero ) break;
                     fBreakPoint(+BearPrefix+NewNumber,i,High1,0,1,BarC,Price);
                     fBreakPoint(+BearPrefix+NewNumber,i,Low2 ,0,1,BarR,Price);
                     if( ! && BarC>BarR ) break;
                     if( BarR>=i- &&  ! ) break;
                     if( Time2[j]>0 || Time3[j]>0 ){
                        NewNumber=fNumberByPoints(+BearPrefix,j,High1);
                        if( NewNumber<1 || NewNumber>Number ) break;
                        if( High3-High[iBarShift(NULL,0,Time3[j])]>-Zero
                         && Low2-Low[iBarShift(NULL,0,Time2[j])]>-Zero
                         &&  ){
                           Error=fFiboLevels(+BearPrefix,NewNumber,j,High1,imin,Low2,i,High3
                                            ,indicator_color4,indicator_color3,,);
                           Time3[j]=Time[i];
                        }
                        if( ! ) break;
                     }
                     else{
                        Number++;
                        NewNumber=Number;
                        if( BarC>BarR ) break;
                     }
                     if( BarR<1 ) BarR=1;
                     Error=fRectangle(+BearPrefix,BearPrefix,NewNumber
                                     ,j,High1,BarR,Low2,imin,High3,,);
                     Error=fFiboLevels(+BearPrefix,NewNumber,j,High1,imin,Low2,i,High3
                                      ,indicator_color4,indicator_color3,,);
                     Time2[j]=Time[imin];
                     Time3[j]=Time[i];
                     break;
               }  }
               if( Up[j]-High2>Zero ){
                  High2=Up[j];
                  imax=j;
               }
               if( Down[j]>Zero && Low2-Down[j]>Zero ){
                  Low2=Down[j];
                  imin=j;
               }
               j++;
      }  }  }
      i--;
   }
   if( iLastTop>0 ) tLastTop=Time[iLastTop];       //   
   if( iLastBottom>0 ) tLastBottom=Time[iLastBottom];
   if( iTop>0 ) tTop=Time[iTop];                   //   
   if( iBottom>0 ) tBottom=Time[iBottom];
   if( iUp>0 ) tUp=Time[iUp];                      //   
   if( iDown>0 ) tDown=Time[iDown];
   return(0);
}
//-----------------------------------------------------------------------------
//  
int fLine(string Name            //  
         ,string Text            //  
         ,int Number             // 
         ,int Bar1,double Price1 //  
         ,int Bar2,double Price2 //  
         ,int Bar3,double Price3 //  
         ,color 
         ,int =0        //    
         ,int =1
         ,int =STYLE_SOLID  // 
         ,bool =true
         ,bool =true ) {
   int Error;
   datetime Time1=Time[Bar1],
            Time2=Time[Bar2];
   if( Number>0 ) Name=Name+Number;
   if( Bar1<=Bar2
    || Bar1<1
    || Bar2<0
    || Price1<Zero
    || Price2<Zero ) {
      Error=MyError;
      Print("***   "+Name+"  , : "
                    +DoubleToStr(Price1,Digits)+" ("+Bar1+"/"+TimeToStr(Time1)+")..."
                    +DoubleToStr(Price2,Digits)+" ("+Bar2+"/"+TimeToStr(Time2)+")");
      return(Error);
   }
   Error=fObjectDelete(Name);
   if( Error>0 && Error<MyError ) {
      return(Error);
   }
   if( ObjectCreate(Name,OBJ_TREND,0,Time1,Price1,Time2,Price2,Time[Bar3],Price3) ) {
      if( Text!="" && Number>0 ) {
         Text=Text+Number;
         =true;
      }
      if( !ObjectSetText(Name, Text)
       || !ObjectSet(Name, OBJPROP_COLOR, )
       || !ObjectSet(Name, OBJPROP_STYLE, )
       || !ObjectSet(Name, OBJPROP_RAY, )
       || !ObjectSet(Name, OBJPROP_TIMEFRAMES, )
       || !ObjectSet(Name, OBJPROP_WIDTH, )
       || !ObjectSet(Name, OBJPROP_BACK, ) ) {
         Error=GetLastError();
         PlaySound("alert.wav");
         Print("***** "+Name+" -    "+Error);
   }  }
   else {
      Error=GetLastError();
      PlaySound("alert.wav");
      Print("***** "+Name+" -   ,  "+Error);
   }
   return(Error);
}
//-----------------------------------------------------------------------------
//     
void fBreakPoint(string Name                 //  
                ,int Bar1,double Price1      //  
                ,double Speed                //  
                ,int Bar2                    //  
                ,int& Bar,double& Price) {   //  
   Bar=0;
   Price=0;
   datetime Time1=Time[Bar1],
            Time2=Time[Bar2];
   if( Bar1<1 || Bar2<1 || Price1<Zero ) {
      Print("***   "+Name+" -  : "
                    +DoubleToStr(Price1,Digits)+" ("+Bar1+"/"+TimeToStr(Time1)
                                            +")...("+Bar2+"/"+TimeToStr(Time2)+")");
      return;
   }
   int Step;
   double H, L, P;
   if( Bar2>Bar1 ) Step=1; else Step=-1;
   if( High[Bar1]-Price1>Zero
    && Price1-Low[Bar1]>Zero ) {             //  
      Bar=Bar1;
      Price=Price1;
      return;
   }
   while( Bar1!=Bar2 ) {
      H=High[Bar1];                          //  
      L=Low[Bar1];
      P=Price1;
      Price1-=Step*Speed;                    //  
      Bar1+=Step;
      if( ( High[Bar1]-Price1>Zero && P-L>Zero )
       || ( Price1-Low[Bar1]> Zero && H-P>Zero ) ) {
         Bar=Bar1;
         Price=Price1;
         return;
   }  }
   return;
}
//-------------------------------------------------------------------+
int ClearScreen(){
   int Error;
   string Name, Pref[];
   Comment("                                                       "+
           "                                                       "+
           "                                                       ");
   ArrayResize(Pref,TypesTotal);
   Pref[0]=;
   int i, k=ObjectsTotal();
   while( k>0 ){
      k--;
      Name=ObjectName(k);
      i=TypesTotal;
      while( i>0 ){
         i--;
         if( StringSubstr(Name,0,StringLen(Pref[i]))!=Pref[i] ) continue;
         Error=fObjectDelete(Name);
   }  }
   return(Error);
}
//+------------------------------------------------------------------+
int fFiboLevels(string Prefix,int Number
              ,int Bar1,double Price1
              ,int Bar2,double Price2
              ,int Bar3,double Price3
              ,color ,color 
              ,int =0,int =1
              ,int =7,int =5
              ,int =STYLE_SOLID,int =STYLE_DOT
              ,bool =false,bool =false){
   if( Bar1<=Bar2 || Bar2<=Bar3 || Bar3<1
    || Price1<Zero || Price2<Zero || Price3<Zero
    || Price3-MathMax(Price1,Price2)>Zero
    || MathMin(Price1,Price2)-Price3>Zero ) return(MyError);
   int Error, Bar4=Bar1-12*(Bar1-Bar2);
   string Name;
   if( Bar4 >= Bar3 ) Bar4=Bar3-10;
   if( Bar4 <  0 )    Bar4=0;
   datetime Time1=Time[Bar1],
            Time2=Time[Bar2],
            Time3=Time[Bar3],
            Time4=Time[Bar4];
   Error=fLine(Prefix+"Start","",Number,Bar3,Price3,Bar4,Price3,0,0,,,1,STYLE_SOLID,false);
   Name=Prefix+"Targets ";
   if( Number>0 ) Name=Name+Number;
   if( ObjectFind(Name)>=0 ) {
      if( !ObjectDelete(Name) ) {
         Error=GetLastError();
         PlaySound("alert.wav");
         Print("***** "+Name+"  ,   "+Error);
         return(Error);
   }  }
   if( ObjectCreate(Name,OBJ_EXPANSION,0,Time1,Price1,Time2,Price2,Time3,Price3) ){
      if( !ObjectSet(Name, OBJPROP_FIBOLEVELS, )
       || !ObjectSet(Name, OBJPROP_COLOR, )
       || !ObjectSet(Name, OBJPROP_STYLE, )
       || !ObjectSet(Name, OBJPROP_WIDTH, )
       || !ObjectSet(Name, OBJPROP_TIMEFRAMES, )
       || !ObjectSet(Name, OBJPROP_LEVELCOLOR, )
       || !ObjectSet(Name, OBJPROP_LEVELSTYLE, )
       || !ObjectSet(Name, OBJPROP_RAY, )
       || !ObjectSet(Name, OBJPROP_BACK, )
       || !ObjectSet(Name, OBJPROP_FIRSTLEVEL+0, 0.618)
       || !ObjectSet(Name, OBJPROP_FIRSTLEVEL+1, 1.000)
       || !ObjectSet(Name, OBJPROP_FIRSTLEVEL+2, 1.618)
       || !ObjectSet(Name, OBJPROP_FIRSTLEVEL+3, 2.618)
       || !ObjectSet(Name, OBJPROP_FIRSTLEVEL+4, 4.236)
       || !ObjectSet(Name, OBJPROP_FIRSTLEVEL+5, 6.854)
       || !ObjectSet(Name, OBJPROP_FIRSTLEVEL+6,11.09 )
       || !ObjectSetFiboDescription(Name, 0, "61.8%")
       || !ObjectSetFiboDescription(Name, 1, " 100%")
       || !ObjectSetFiboDescription(Name, 2, " 162%")
       || !ObjectSetFiboDescription(Name, 3, " 262%")
       || !ObjectSetFiboDescription(Name, 4, " 424%")
       || !ObjectSetFiboDescription(Name, 5, " 685%")
       || !ObjectSetFiboDescription(Name, 6, "1109%") ){
         Error=GetLastError();
         PlaySound("alert.wav");
         Print("****  "+Name+" -    "+Error);
   }  }
   else {
      Error=GetLastError();
      PlaySound("alert.wav");
      Print("***** "+Name+"  ,  "+Error);
   }
   Name=Prefix+"Recoils ";
   if( Number>0 ) Name=Name+Number;
   if( ObjectFind(Name)>=0 ) {
      if( !ObjectDelete(Name) ) {
         Error=GetLastError();
         PlaySound("alert.wav");
         Print("***** "+Name+"  ,   "+Error);
         return(Error);
   }  }
   if( ObjectCreate(Name,OBJ_FIBO,0,Time1,Price1,Time2,Price2) ){
      if( !ObjectSet(Name, OBJPROP_FIBOLEVELS, )
       || !ObjectSet(Name, OBJPROP_COLOR, )
       || !ObjectSet(Name, OBJPROP_STYLE, )
       || !ObjectSet(Name, OBJPROP_TIMEFRAMES, )
       || !ObjectSet(Name, OBJPROP_LEVELCOLOR, )
       || !ObjectSet(Name, OBJPROP_LEVELSTYLE, )
       || !ObjectSet(Name, OBJPROP_RAY, false)
       || !ObjectSet(Name, OBJPROP_BACK, )
       || !ObjectSet(Name, OBJPROP_FIRSTLEVEL+0, 0.0)
       || !ObjectSet(Name, OBJPROP_FIRSTLEVEL+1, 0.236)
       || !ObjectSet(Name, OBJPROP_FIRSTLEVEL+2, 0.382)
       || !ObjectSet(Name, OBJPROP_FIRSTLEVEL+3, 0.618)
       || !ObjectSet(Name, OBJPROP_FIRSTLEVEL+4, 1.0)
       || !ObjectSetFiboDescription(Name, 0, "   0.0%")
       || !ObjectSetFiboDescription(Name, 1, " -23.6%")
       || !ObjectSetFiboDescription(Name, 2, " -38.2%")
       || !ObjectSetFiboDescription(Name, 3, " -61.8%")
       || !ObjectSetFiboDescription(Name, 4, "-100.0%") ){
         Error=GetLastError();
         PlaySound("alert.wav");
         Print("****  "+Name+" -    "+Error);
   }  }
   else {
      Error=GetLastError();
      PlaySound("alert.wav");
      Print("***** "+Name+"  ,  "+Error);
   }
   return(Error);
}
//+------------------------------------------------------------------+
int fNumberByPoints(string Prefix
                   ,int Bar,double Price=0
                   ,int N=1){
   int Number, PropertyT, PropertyP,
       k=ObjectsTotal(), Lenth=StringLen(Prefix);
   double P;
   datetime T;
   string Name;
   switch( N ){
      case 3:  PropertyT=OBJPROP_TIME3;
               PropertyP=OBJPROP_PRICE3;
               break;
      case 2:  PropertyT=OBJPROP_TIME2;
               PropertyP=OBJPROP_PRICE2;
               break;
      default: PropertyT=OBJPROP_TIME1;
               PropertyP=OBJPROP_PRICE1;
   }
   while( k>0 ){
      k--;
      Name=ObjectName(k);
      if( StringSubstr(Name,0,Lenth)!=Prefix ) continue;
      T=ObjectGet(Name,PropertyT);
      if( iBarShift(NULL,0,T)!=Bar ) continue;
      if( Price>Zero ){
         P=ObjectGet(Name,PropertyP);
         if( MathAbs(P-Price)>Zero ) continue;
      }
      Number=StrToInteger(StringSubstr(Name,Lenth));
      if( Number>0 ) break;
   }
   return(Number);
}
//-------------------------------------------------------------------+
int fObjectDelete(string Name){
   int Error;
   if( ObjectFind(Name)==0 ){
      if( !ObjectDelete(Name) ){
         Error=GetLastError();
         PlaySound("alert.wav");
         Print("***** "+Name+" -     "+Error);
   }  }
   else Error=MyError;
   return(Error);
}
//-------------------------------------------------------------------+
int fRectangle(string Name,string Text
              ,int Group
              ,int Bar1,double Price1
              ,int Bar2,double Price2
              ,int Bar3,double Price3
              ,color 
              ,int =0,bool =true ) {
   int Error;
   datetime Time1=Time[Bar1],
            Time2=Time[Bar2],
            Time3=0;
   if( Group>0 ) Name=Name+Group;
   if( Bar1<=Bar2 || Bar1<2 || Bar2<1 || Price1<Zero || Price2<Zero ) {
      Print("***   "+Name+"  , : "
           +DoubleToStr(Price1,Digits)+" ("+Bar1+"/"+TimeToStr(Time1)+")..."
           +DoubleToStr(Price2,Digits)+" ("+Bar2+"/"+TimeToStr(Time2)+")");
      return(MyError);
   }
   if( ObjectFind(Name)==0 ) {
      if( !ObjectDelete(Name) ) {
         Error=GetLastError();
         PlaySound("alert.wav");
         Print("***** "+Name+"  ,   "+Error);
         return(Error);
   }  }
   if( Bar3>1 ) Time3=Time[Bar3];
   if( ObjectCreate(Name,OBJ_RECTANGLE,0,Time1,Price1,Time2,Price2,Time3,Price3) ){
      if( !ObjectSetText(Name, Text)
       || !ObjectSet(Name, OBJPROP_COLOR, )
       || !ObjectSet(Name, OBJPROP_TIMEFRAMES, )
       || !ObjectSet(Name, OBJPROP_BACK, ) ) {
         Error=GetLastError();
         PlaySound("alert.wav");
         Print("***** "+Name+" -    "+Error);
   }  }
   else {
      Error=GetLastError();
      PlaySound("alert.wav");
      Print("***** "+Name+"  ,  "+Error);
   }
   return(Error);
}
//+------------------------------------------------------------------+
void fSoftFractals(int i                           //  
                  ,int iLastB,int iLastT           //   
                  ,double& B[],double& T[]         //   
                  ,int Left=1,int Right=1){        //  
   if( i<=Right ) return;
   double C[];
   int dim=ArrayResize(C,Left+1+Right), j;
      if( iLastB-Right>i || iLastB<1 ){            //   
         j=0;
         B[i]=0;
         while( j < dim ){
            C[j]=Low[j+i-Right];
            j++;
         }
         if( C[Right+1]-C[Right]>-Zero
          && C[Right-1]-C[Right]>-Zero ) {
            B[i]=C[Right];                         //  
            j=1;
            while ( j < dim ) {
               if( ( j<Right && B[i]-C[j-1]>Zero )
                || ( j>Right && B[i]-C[j]  >Zero ) ) {
                  B[i]=0;                          //  
                  break;
               }
               j++;
      }  }  }
   if( iLastT-Right>i || iLastT<1 ){               //   
      j=0;
      T[i]=0;
      while( j<dim ){
         C[j]=High[j+i-Right];
         j++;
      }
      if( C[Right]-C[Right+1]>-Zero
       && C[Right]-C[Right-1]>-Zero ) {
         T[i]=C[Right];                            //  
         j=1;
         while ( j < dim ) {
            if( ( j<Right && C[j-1]-T[i]>Zero )
             || ( j>Right && C[j]  -T[i]>Zero ) ) {
               T[i]=0;                             //  
               break;
            }
            j++;
      }  }  }
   return;
}